<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class PageRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(Auth::user()->role == 'admin' )
        {
            return true;
        }

        if(Auth::user()->hasModule( 'pages' ) )
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=['image' => 'sometimes'];

        foreach (languages() as $lang) {
            $lang_rules=[
                'title_'.$lang->local=> 'required|min:3',
                'slug_'.$lang->local=> [
                    "required",
                    Rule::unique('page_descriptions', 'slug')->ignore($this->page? $this->page->id : 0, 'page_id')
                ],
                'keywords_'.$lang->local=> 'required|min:3',
                'meta_description_'.$lang->local=> 'required|min:3',
                'description_'.$lang->local=> 'required|min:3',
            ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes=[];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local=> __('pages.title'),
                'slug_'.$lang->local=>  __('pages.slug'),
                'keywords_'.$lang->local=> __('pages.keywords'),
                'meta_description_'.$lang->local=> __('pages.meta_description'),
                'description_'.$lang->local=> __('pages.description'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
//            throw new HttpResponseException(response($validator->errors()->first(), 302));
            parent::failedValidation($validator);
        }
    }
}
